
'=====================================================
'                                                    '
'        ---------------------------------           '                                                  
'           CustomWindow.inc (Version 4)             '
'        ---------------------------------           '
'                                                    '
'     This include file will let you create a        ' 
'                 custom window.                     '
'                                                    '
'                    By Andy.                        '
'                                                    '
'=====================================================

$use "customwindowlib.lib"

'Minimise and close images - image size is (36 x 26).
uint cwMinOn = loadimage(getstartpath + "minon.jpg",@IMGSCALABLE) '<-- Image for mouse over min button.
uint cwMinOff = loadimage(getstartpath + "minoff.jpg",@IMGSCALABLE) '<-- Image for mouse not over min button.
uint cwCloseOn = loadimage(getstartpath + "closeon.jpg",@IMGSCALABLE) '<-- Image for mouse over close button.
uint cwCloseoff = loadimage(getstartpath + "closeoff.jpg",@IMGSCALABLE) '<-- Image for mouse not over close button.

'Library external routines.
declare extern CreateCaption(window WinIn,int CaptionID,string CaptionIn,int MinIn,int CloseIn),int
declare extern CreateBorder(window WinIn,int IconIn,opt uint ColorIn),int
declare extern MyMenuTitle(string ButText,int ControlID,opt Uint FColourIn,opt Uint BColourIn,opt Uint HFColourIn,opt Uint HBColourIn),int
declare extern MyMenuItem(string ButText,int ControlID,opt int ControlIcon,opt int StyleIn,opt int ColorFIn,opt int ColorBIn),int
declare extern MyPopupTitle(string ButText,int ControlID,opt int ControlIcon,opt int StyleIn,opt int ColorFIn,opt int ColorBIn),int
declare extern MyPopupEnd(),int
declare extern MyPopupItem(string ButText,int ControlID,opt int ControlIcon,opt int StyleIn,opt int ColorFIn,opt int ColorBIn),int
declare extern MySeparator(int ControlID),int
declare extern MyPopupSeparator(int ControlID),int
declare extern MyMenuUpdate(window WinIn),int
declare extern MyMenuEnd(window WinIn),int
declare extern HighlightMenuItems(window WinIn),int
declare extern ShowMenuItems(window WinIn,int MenuID),int
declare extern HideMenuItems(window WinIn,int MenuID),int
declare extern MenuClicked(window WinIn,int MenuID),int
declare extern HideAllMenuItems(window WinIn),int
declare extern EnableControls(window WinIn)
declare extern MenuChanged(window WinIn),int
declare extern MenuClickOff(window WinIn),int
declare extern MenuCheck(window WinIn),int
declare extern ExtractResource(id:INT, restype:INT, filename:STRING)
declare extern cwSubClassControl(WINDOW parent,INT id)
declare extern cwUnSubClassControl(WINDOW parent,INT id)
declare extern WindowResize(window WinIn,int CaptionIn,int MinIn,int CloseIn),int
declare extern MyWindowDone(window WinIn,int CaptionIn,int MinIn,int CloseIn),int
declare extern WindowMinSize(int MinXin,int MinYin,opt int MaxXin,opt int MaxYin),int 
declare extern DisablePopup(window WinIn,int ControlIn),int
declare extern EnablePopup(window WinIn,int ControlIn),int
declare extern DisableMenuTitle(window WinIn,int ControlIn),int
declare extern EnableMenuTitle(window WinIn,int ControlIn),int
declare extern DisableItem(window WinIn,int ControlIn),int
declare extern EnableItem(window WinIn,int ControlIn),int

'Library external variables.
EXTERN cwPictureWidth as int  : cwPictureWidth = 36
EXTERN cwPictureHieght as int : cwPictureHieght = 26
EXTERN cwMenuItm as int : cwMenuItm = cwPictureHieght
EXTERN cwCaptionPosition as INT : cwCaptionPosition = cwPictureWidth
EXTERN cwAcross as int : cwAcross = 10
EXTERN cwl,cwt,cww,cwh AS INT                  
EXTERN cwYloop AS INT
EXTERN cwZloop AS INT
EXTERN cwMinPos AS INT
EXTERN cwClosePos AS INT
EXTERN cwMyControlsBeginAt AS INT
EXTERN cwMyControlsEndAt AS INT
EXTERN cwCaptionWidth AS INT
EXTERN cwMenuCount AS INT
EXTERN cwItemCount AS INT
EXTERN cwTotalMenuItems AS INT
EXTERN cwSeparatorItems AS INT
EXTERN cwMenuItems AS INT
EXTERN cwMenus[100] AS INT
EXTERN cwMenusFC[100] AS INT
EXTERN cwMenusBC[100] AS INT
EXTERN cwMenusHFC[100] AS INT
EXTERN cwMenusHBC[100] AS INT
EXTERN cwMenuTitles[100,1000] AS INT
EXTERN cwMenuItemT[1000] AS INT
EXTERN cwMenuItemD[100,1000] AS INT
EXTERN cwMenuItemDtype[100,1000] AS INT
extern cwMenuItemStyle[1000] as int
extern cwMenuItemFg[1000] as int
extern cwMenuItemBg[1000] as int
extern cwMenuItemFgD[100,1000] as int
extern cwMenuItemBgD[100,1000] as int
EXTERN cwMenuItemI[100,1000] AS INT
EXTERN cwMenuPopup[100,1000] AS INT
extern cwMenuPopParent[100] as int 
EXTERN cwMenuItemParent[100,1000] AS INT
EXTERN cwMenuItemShow[100,1000] AS INT
extern cwPopupDisabled[100,1000] as int 
EXTERN cwMenuPopupCount AS INT
extern cwItemDisabled[100,1000] as int 
extern cwItemDisabledID[100,1000] as int 
EXTERN cwMenuItemType[1000] AS INT
EXTERN cwPopupShowing[1000] AS INT
EXTERN cwPopupShowingCount AS INT
EXTERN cwPopupHide AS INT
EXTERN cwNotOver AS INT
EXTERN cwMenuClick[1000] AS INT
EXTERN cwMenuHighlted[1000] AS INT
EXTERN cwLongestMenuItem AS INT
EXTERN cwMenupopups AS INT
EXTERN cwMenuIcon AS INT
EXTERN cwDisplayItems AS INT
EXTERN cwDisplayOver AS INT
EXTERN cwShowingMenu AS INT
EXTERN cwShowingParent AS INT
EXTERN cwa,cwb,cwpop1 as int
EXTERN cwPopitm AS INT
EXTERN cwMenuStore AS INT
EXTERN cwPreviousMouseOver AS INT
EXTERN cwCurrentTitle AS INT
EXTERN cwCurrentPopup AS INT
extern cwOriginalSize as int 
extern cwPreviousWidth as int 
extern cwPreviousWidth2 as int 
EXTERN cwMenuItemText[1000] AS string
extern cwCurrentWindow as window
extern cwMinControlID as int
extern cwCloseControlID as int 
extern cwCaptionControlID as int
extern cwTotalDown as int 
extern cwl88 as int
extern cwt88 as int
extern cww88 as int
extern cwh88 as int
extern cwMTLit as int 
extern cwDefaultTextSize as int 
extern cwDefaultTextFont as string
extern cwDefaultHFC as int 
extern cwDefaultHBC as int 

'Default Menu Title Highlighted foreground colour.
cwDefaultHFC = rgb(0,0,0)

'Default Menu Title Highlighted Background colour.
cwDefaultHBC = rgb(135,206,250)

'Default Menu Title / Menu item / Popup text size.
cwDefaultTextSize = 10

'Default Menu Title / Menu item / Popup text font.
cwDefaultTextFont = "Arial"

int cwNewSize = 0

sub RegisterControls(window WinIn),int
	 MouseOverControl(WinIn,cwMinControlID)   '<-- minimise button.
	 MouseOverControl(WinIn,cwCloseControlID) '<-- close button.
	 MouseOverControl(WinIn,cwCaptionControlID)
return 0
endsub

sub CheckWindow(window WinIn),int

	  'Detect if the mouse is over the close box or not.
	  if MouseOver(WinIn,cwCloseControlID)
		  showimage WinIn,cwCloseOn,@IMGSCALABLE,cwClosePos+cwNewSize,0
        showimage WinIn,cwMinOff,@IMGSCALABLE,cwMinPos+cwNewSize,0
        goto cwMinCloseCheckLabel
	  else
		  showimage WinIn,cwCloseOff,@IMGSCALABLE,cwClosePos+cwNewSize,0
	  endif

	  'Detect if the mouse is over the minimise box or not.
	  if MouseOver(WinIn,cwMinControlID)
		  showimage WinIn,cwMinOn,@IMGSCALABLE,cwMinPos+cwNewSize,0
		  showimage WinIn,cwCloseOff,@IMGSCALABLE,cwClosePos+cwNewSize,0
	  else
		  showimage WinIn,cwMinOff,@IMGSCALABLE,cwMinPos+cwNewSize,0
	  endif

     label cwMinCloseCheckLabel
	  'Close window clicked.
	  if ControlClick(WinIn,cwCloseControlID)
		  stoptimer WinIn
		  closewindow WinIn
     else
        goto cwMinCheckLabel
	  endif

     label cwMinCheckLabel
	  'Minimised clicked.
	  if ControlClick(WinIn,cwMinControlID)
		  showwindow WinIn,@SWMINIMIZED
	  endif

     MenuCheck(WinIn)

return 0
endsub

'Routine to resize / move the window.
sub MoveTheWindow(window WinIn),int
	  getsize cwCurrentWindow,cwl88,cwt88,cww88,cwh88
	  if cwPreviousWidth2 <> cww88
		  cwPreviousWidth2 = cww88
		  cwNewSize = 0
		  cwNewSize = cwPreviousWidth2 - cwOriginalSize
		  setsize cwCurrentWindow,cwCaptionPosition,1,cwCaptionWidth+cwNewSize,cwPictureHieght,cwCaptionControlID
		  setsize cwCurrentWindow,cwMinPos+cwNewSize,1,cwCaptionWidth+cwNewSize,cwPictureHieght,cwMinControlID
		  setsize cwCurrentWindow,cwClosePos+cwNewSize,1,cwCaptionWidth+cwNewSize,cwPictureHieght,cwCloseControlID
		  TrackWindow(WinIn)
	  endif
return 0
endsub

'Delete custom window images when closing a window and un-subclass the caption control.
sub CloseCaption(),int
	 cwUnSubClassControl(cwCurrentWindow,cwCaptionControlID)
	 if cwCloseOn  then deleteimage cwCloseOn,@IMGSCALABLE
	 if cwCloseOff then deleteimage cwCloseOff,@IMGSCALABLE
	 if cwMinOn    then deleteimage cwMinOn,@IMGSCALABLE
	 if cwMinOff   then deleteimage cwMinOff,@IMGSCALABLE 
return 0
endsub

'=====================================================
'                                                    '
'        -----------------------------------         '                                                  
'        End of CustomWindow.inc (Version 4)         '
'        -----------------------------------         '
'                                                    ' 
'=====================================================

